//A2-SRCLK serial shift clock
//A1-RCLK output latch clock
//A0-SER serial data in

void setup()
{
	DDRC |= B00000111;//Set pins A0,A1,A2 as output
	PORTC &= B11111000;//Clear all pins
}

void loop()
{
	volatile uint8_t value;
	value=B11111111,
	shiftByte(&value);
	delay(500);
	value=B11111110;
	shiftByte(&value);
	delay(500);
	value=B11111100;
	shiftByte(&value);
	delay(500);
	value=B11111000;
	shiftByte(&value);
	delay(500);
	value=B01111000;
	shiftByte(&value);
	delay(500);
	
	
	
}

void shiftByte( uint8_t *x){
	//2.8us function
	asm volatile(
	"in __tmp_reg__, __SREG__	\n\t"
	"cbi %[port],%[load]		\n\t"//Set data load bit low
    "ld r24, %a[data]			\n\t" //Load data to r24
    "in r23, %[port]			\n\t" //Load port bits state to r23
	"cbr r23,0b00000100			\n\t" //Set clock bit low in register
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port bit7 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit6 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit5 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit4 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit3 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit2 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit1 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"lsl r24					\n\t" //left shift r24
	"bst r24,7					\n\t"//Store bit 7 from data
	"bld r23,%[dout]			\n\t"//Load bit to port register
	"out %[port],r23			\n\t" //Write to output port  bit0 and clock low
	"sbi %[port],%[clk]			\n\t"//Set clock bit high
	"sbi %[port],%[load]		\n\t"//Set data load bit high
	"out __SREG__, __tmp_reg__ 	\n\t"
    :
    :[data] "e" (x),[port] "I" (_SFR_IO_ADDR(PORTC)),[clk] "I" (PORTC2),[dout] "I" (PORTC0),[load] "I" (PORTC1)
    : "r24","r23"
	);
}

